---
title: WindowEventHandlers.onbeforeunload
slug: Web/API/WindowEventHandlers/onbeforeunload
tags:
  - API
  - Event Handler
  - HTML DOM
  - Property
  - Reference
  - Window
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <code><strong>onbeforeunload</strong></code> property of the {{domxref("WindowEventHandlers")}} mixin is the {{domxref("EventHandler")}} for processing {{event("beforeunload")}} events. These events fire when a window is about to {{event("unload")}} its resources. At this point, the document is still visible and the event is still cancelable.</p>

<div class="note">
<p><strong>Note:</strong> To combat unwanted pop-ups, some browsers don't display prompts created in <code>beforeunload</code> event handlers unless the page has been interacted with. Moreover, some don't display them at all.</p>
</div>

<div class="notecard note">
<p><strong>Note</strong>: You shouldn't use the <code><a href="/en-US/docs/Web/API/Window/beforeunload_event">beforeunload</a></code> event with <code>sendBeacon()</code>. See the <code><a href="/en-US/docs/Web/API/Navigator/sendBeacon">Navigator.sendBeacon()</a></code> page for more details and best practices.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">window.addEventListener("beforeunload", function(event) { ... });
window.onbeforeunload = function(event) { ... };</pre>

<p>Typically, it is better to use {{domxref("EventTarget.addEventListener", "window.addEventListener()")}} and the {{event("beforeunload")}} event, instead of <code>onbeforeunload</code>.</p>

<h2 id="Example">Example</h2>

<p>This example prompts the user before unloading.</p>

<p>The HTML specification states that authors should use the {{domxref("Event.preventDefault()")}} method instead of using {{domxref("Event.returnValue")}} to prompt the user.</p>

<pre class="brush:js notranslate">window.addEventListener('beforeunload', function (e) {
  // Cancel the event
  e.preventDefault(); // If you prevent default behavior in Mozilla Firefox prompt will always be shown
  // Chrome requires returnValue to be set
  e.returnValue = '';
});
</pre>

<p>Guarantee the browser unload by removing the <em>returnValue</em> property of the event</p>

<pre class="brush:js notranslate">window.addEventListener('beforeunload', function (e) {
  // the absence of a returnValue property on the event will guarantee the browser unload happens
  delete e['returnValue'];
});</pre>

<h2 id="Notes">Notes</h2>

<p>When your page uses JavaScript to render content, the JavaScript may stop when leaving and then navigating back to the page. You can bind to <code>window.onbeforeunload</code> to prevent the browser from fully caching the page. If you do so, JavaScript in the page will be triggered on the subsequent return visit and update the content as desired.</p>

<h2 id="Specifications">Specifications</h2>

<p>The event was originally introduced by Microsoft in Internet Explorer 4 and standardized in the HTML5 specification.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#handler-window-onbeforeunload', 'onbeforeunload')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', '#windoweventhandlers', 'GlobalEventHandlers')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "#windoweventhandlers", "GlobalEventHandlers")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WindowEventHandlers.onbeforeunload")}}</p>

<p>The HTML specification states that authors should use the {{domxref("Event.preventDefault()")}} method instead of using {{domxref("Event.returnValue")}} to prompt the user. However, this is not yet supported by all browsers.</p>

<p>When this event returns (or sets the <code>returnValue</code> property to) a value other than <code>null</code> or <code>undefined</code>, the user will be prompted to confirm the page unload. In older browsers, the return value of the event is displayed in this dialog. Starting with Firefox 44, Chrome 51, Opera 38, and Safari 9.1, a generic string not under the control of the webpage will be shown instead of the returned string. For example:</p>

<ul>
 <li>Firefox displays the string, "This page is asking you to confirm that you want to leave - data you have entered may not be saved." (see {{bug("588292")}}).</li>
 <li>Chrome displays the string, "Do you want to leave this site? Changes you made may not be saved." (see <a href="https://www.chromestatus.com/feature/5349061406228480">Chrome Platform Status</a>).</li>
</ul>

<p>Internet Explorer does not respect the <code>null</code> return value and will display this to users as "null" text. You have to use <code>undefined</code> to skip the prompt.</p>

<p>In some browsers, calls to {{domxref("window.alert()")}}, {{domxref("window.confirm()")}}, and {{domxref("window.prompt()")}} may be ignored during this event. See the <a href="http://www.w3.org/TR/html5/webappapis.html#user-prompts">HTML specification</a> for more details.</p>

<p>Note also, that various browsers ignore the result of the event and do not ask the user for confirmation at all. In such cases, the document will always be unloaded automatically. Firefox has a switch named <code>dom.disable_beforeunload</code> in <em>about:config</em> to enable this behaviour. As of Chrome 60, the confirmation <a href="https://www.chromestatus.com/feature/5082396709879808">will be skipped</a> if the user has not performed a gesture in the frame or page since it was loaded. Pressing F5 in the page seems to count as user interaction, whereas mouse-clicking the refresh arrow or pressing F5 with Chrome DevTools focused does not count as user interaction (as of Chrome 81).</p>
